!***********************************************************************
!***  simple test program for PCL

      PROGRAM PCL_test
!*** declarations
      IMPLICIT NONE
      INCLUDE 'pclh.f'
      INTEGER N
      PARAMETER(N=200)
      INTEGER counter_list(1), event, flags, res
      INTEGER*8 i_result, descr
      REAL*8 fp_result
      EXTERNAL matadd
      REAL*8 a(N,N), b(N,N), c(N,N)


      WRITE(*,*)
      WRITE(*,*) 'Fortran test program for PCL'
      res = PCLinit(descr)
      IF(res .NE. PCL_SUCCESS) THEN
         WRITE(*,*) 'error on PCLinit'
         STOP
      ENDIF

!*** count for user mode (on MIPS PCL_MODE_USER)
      flags = PCL_MODE_USER
!***  loop over all defined event types
      DO event=0,PCL_MAX_EVENT-1

         counter_list(1) = event
!***     check if event is available
         res = PCLquery(descr, counter_list, 1, flags)
         IF(res .EQ. PCL_SUCCESS) THEN

!***        start counting
            IF(PCLstart(descr,counter_list,1,flags).NE.PCL_SUCCESS) THEN
               WRITE(*,*) 'problem with starting event ',event
            ENDIF

!***        do some work
            CALL matadd(a,b,c,n)

!***        stop counting
            res = PCLstop(descr, i_result, fp_result, 1)
            IF(res .NE. PCL_SUCCESS) THEN
               WRITE(*,*) 'problem with stopping event ',event
            ELSE
               IF(event .LT. PCL_MFLOPS) THEN
!***              integer result
                  WRITE(*,*) 'event ', event, ': ', i_result
               ELSE
                  WRITE(*,*) 'event ', event, ': ', fp_result
               ENDIF
            ENDIF

         ELSE
!***        event not supported
            WRITE(*,*) 'event ', event, ' not supported (',res,')'
         ENDIF
      ENDDO

      CALL dummyout(a, n)

      STOP
      END

!***********************************************************************

      SUBROUTINE matadd(a,b,c,n)
      IMPLICIT NONE
      INTEGER N,i,j
      REAL*8 a(N,N), b(N,N), c(N,N)

      DO i=1,n
         DO j=1,n
            a(i,j) = b(i,j) * c(i,j)
         ENDDO
      ENDDO

      RETURN
      END

!***********************************************************************

      SUBROUTINE dummyout(a,n)
      IMPLICIT NONE
      INTEGER n
      REAL*8 a(n,n)
      
      write(*,*)'this output prevents optimizations we dont want',a(n,n)

      RETURN
      END

!***********************************************************************
